#include "stdafx.h"
#include "testtfileview.h"
#include "MainFrm.h"
#include "testtfileviewDoc.h"
#include "testtfileviewView.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#endif


#pragma warning(suppress: 26409 26433 26440 26477)
IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

#pragma warning(suppress: 26433 26440)
BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd) //NOLINT(modernize-avoid-c-arrays)
  ON_WM_CREATE()
  ON_WM_DEVICECHANGE()
END_MESSAGE_MAP()

std::array<UINT, 4> g_indicators
{ {
  ID_SEPARATOR,
  ID_INDICATOR_CAPS,
  ID_INDICATOR_NUM,
  ID_INDICATOR_SCRL,
} };

CMainFrame::CMainFrame() noexcept //NOLINT(modernize-use-equals-default)
{
}

#pragma warning(suppress: 26434)
int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
  //Let the base class do its thing
  if (__super::OnCreate(lpCreateStruct) == -1)
    return -1;

  if (!m_wndToolBar.Create(this) || !m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
  {
    TRACE(_T("Failed to create toolbar\n"));
    return -1;
  }

#pragma warning(suppress: 26472)
  if (!m_wndStatusBar.Create(this) || !m_wndStatusBar.SetIndicators(g_indicators.data(), static_cast<int>(g_indicators.size())))
  {
    TRACE(_T("Failed to create status bar\n"));
    return -1;
  }

  m_wndToolBar.SetBarStyle(m_wndToolBar.GetBarStyle() |	CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC);
  m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
  EnableDocking(CBRS_ALIGN_ANY);
  DockControlBar(&m_wndToolBar);
  return 0;
}

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
  //Let the base class do its thing
  __super::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
  //Let the base class do its thing
  __super::Dump(dc);
}
#endif //_DEBUG

#pragma warning(suppress: 26434)
BOOL CMainFrame::OnDeviceChange(UINT /*nEventType*/, DWORD_PTR /*dwData*/)
{
#pragma warning(suppress: 26466)
  auto pView = static_cast<CTesttfileviewView*>(GetActiveFrame()->GetActiveView());
  if (pView != nullptr)
    pView->PostMessage(WM_COMMAND, ID_TREEFILECTRL_REFRESH, 0);

  return 0L;
}
