#pragma once

#include "FileTreeCtrl.h"


class CMyTreeFileCtrl : public CFileTreeCtrl
{
protected:
  //Just override one method for demonstration purposes
  void OnSelectionChanged(_In_ NM_TREEVIEW* pTreeView, _In_ const CString& sPath) override;
};

class CTesttfileviewView : public CView
{
protected: //create from serialization only
  CTesttfileviewView() noexcept;
  DECLARE_DYNCREATE(CTesttfileviewView)

public:
//Methods
  CTesttfileviewDoc* GetDocument();
  void OnDraw(CDC* pDC) noexcept override;
  BOOL PreCreateWindow(CREATESTRUCT& cs) override;
  BOOL OnPreparePrinting(CPrintInfo* pInfo) override;
  void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo) noexcept override;
  void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo) noexcept override;
  void OnInitialUpdate() override;
  BOOL OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo) override;
#ifdef _DEBUG
  void AssertValid() const override;
  void Dump(CDumpContext& dc) const override;
#endif

protected:
//Message handlers
  afx_msg int  OnCreate(LPCREATESTRUCT lpCreateStruct);
  afx_msg void OnSize(UINT nType, int cx, int cy);
  afx_msg void OnSetFocus(CWnd* pOldWnd);
  afx_msg void OnToolsAllowDelete() noexcept;
  afx_msg void OnUpdateToolsAllowDelete(CCmdUI* pCmdUI);
  afx_msg void OnToolsAllowCreateFolder() noexcept;
  afx_msg void OnUpdateToolsAllowCreateFolder(CCmdUI* pCmdUI);
  afx_msg void OnToolsAllowOpen() noexcept;
  afx_msg void OnUpdateToolsAllowOpen(CCmdUI* pCmdUI);
  afx_msg void OnToolsAllowRename() noexcept;
  afx_msg void OnUpdateToolsAllowRename(CCmdUI* pCmdUI);
  afx_msg void OnToolsAllowProperties() noexcept;
  afx_msg void OnUpdateToolsAllowProperties(CCmdUI* pCmdUI);
  afx_msg void OnToolsShowFiles();
  afx_msg void OnUpdateToolsShowFiles(CCmdUI* pCmdUI);
  afx_msg void OnToolsAllowDragDrop() noexcept;
  afx_msg void OnUpdateToolsAllowDragDrop(CCmdUI* pCmdUI);
  afx_msg void OnToolsHideCDROM();
  afx_msg void OnUpdateToolsHideCDROM(CCmdUI* pCmdUI);
  afx_msg void OnToolsHideFixed();
  afx_msg void OnUpdateToolsHideFixed(CCmdUI* pCmdUI);
  afx_msg void OnToolsHideRAMDisks();
  afx_msg void OnUpdateToolsHideRAMDisks(CCmdUI* pCmdUI);
  afx_msg void OnToolsHideRemovable();
  afx_msg void OnUpdateToolsHideRemovable(CCmdUI* pCmdUI);
  afx_msg void OnToolsHideRemote();
  afx_msg void OnUpdateToolsHideRemote(CCmdUI* pCmdUI);
  afx_msg void OnToolsFileNameMask();
  afx_msg void OnToolsHideHidden();
  afx_msg void OnUpdateToolsHideHidden(CCmdUI* pCmdUI);
  afx_msg void OnToolsHideArchive();
  afx_msg void OnUpdateToolsHideArchive(CCmdUI* pCmdUI);
  afx_msg void OnToolsHideCompressed();
  afx_msg void OnUpdateToolsHideCompressed(CCmdUI* pCmdUI);
  afx_msg void OnToolsHideSystem();
  afx_msg void OnUpdateToolsHideSystem(CCmdUI* pCmdUI);
  afx_msg void OnToolsHideTemporary();
  afx_msg void OnUpdateToolsHideTemporary(CCmdUI* pCmdUI);
  afx_msg void OnToolsHideEncrypted();
  afx_msg void OnUpdateToolsHideEncrypted(CCmdUI* pCmdUI);
  afx_msg void OnToolsHideOffline();
  afx_msg void OnUpdateToolsHideOffline(CCmdUI* pCmdUI);
  afx_msg void OnToolsHideReadOnly();
  afx_msg void OnUpdateToolsHideReadOnly(CCmdUI* pCmdUI);
  afx_msg void OnToolsHideReparsePoint();
  afx_msg void OnUpdateToolsHideReparsePoint(CCmdUI* pCmdUI);
  afx_msg void OnToolsHideSparse();
  afx_msg void OnUpdateToolsHideSparse(CCmdUI* pCmdUI);
  afx_msg void OnToolsHideHidden2();
  afx_msg void OnUpdateToolsHideHidden2(CCmdUI* pCmdUI);
  afx_msg void OnToolsHideArchive2();
  afx_msg void OnUpdateToolsHideArchive2(CCmdUI* pCmdUI);
  afx_msg void OnToolsHideCompressed2();
  afx_msg void OnUpdateToolsHideCompressed2(CCmdUI* pCmdUI);
  afx_msg void OnToolsHideSystem2();
  afx_msg void OnUpdateToolsHideSystem2(CCmdUI* pCmdUI);
  afx_msg void OnToolsHideTemporary2();
  afx_msg void OnUpdateToolsHideTemporary2(CCmdUI* pCmdUI);
  afx_msg void OnToolsHideEncrypted2();
  afx_msg void OnUpdateToolsHideEncrypted2(CCmdUI* pCmdUI);
  afx_msg void OnToolsHideOffline2();
  afx_msg void OnUpdateToolsHideOffline2(CCmdUI* pCmdUI);
  afx_msg void OnToolsHideReadOnly2();
  afx_msg void OnUpdateToolsHideReadOnly2(CCmdUI* pCmdUI);
  afx_msg void OnToolsHideReparsePoint2();
  afx_msg void OnUpdateToolsHideReparsePoint2(CCmdUI* pCmdUI);
  afx_msg void OnToolsHideSparse2();
  afx_msg void OnUpdateToolsHideSparse2(CCmdUI* pCmdUI);
  afx_msg void OnToolsAutoRefresh();
  afx_msg void OnUpdateToolsAutoRefresh(CCmdUI* pCmdUI);
  afx_msg void OnToolsSetRootFolder();
  afx_msg void OnDestroy();
  afx_msg void OnToolsHideNetwork();
  afx_msg void OnUpdateToolsHideNetwork(CCmdUI* pCmdUI);
  afx_msg void OnToolsShowSharedFolders();
  afx_msg void OnUpdateToolsShowSharedFolders(CCmdUI* pCmdUI);
  afx_msg void OnToolsShowAllNetworkItems();
  afx_msg void OnUpdateToolsShowAllNetworkItems(CCmdUI* pCmdUI);
  afx_msg void OnToolsShowNetworkPrinters();
  afx_msg void OnUpdateToolsShowNetworkPrinters(CCmdUI* pCmdUI);
  afx_msg void OnToolsShowNetworkShares();
  afx_msg void OnUpdateToolsShowNetworkShares(CCmdUI* pCmdUI);
  afx_msg void OnToolsShowDriveLabels();
  afx_msg void OnUpdateToolsShowDriveLabels(CCmdUI* pCmdUI);
  afx_msg void OnToolsHideMyComputer();
  afx_msg void OnUpdateToolsHideMyComputer(CCmdUI* pCmdUI);
  afx_msg void OnToolsShowRootedFolder();
  afx_msg void OnUpdateToolsShowRootedFolder(CCmdUI* pCmdUI);
  afx_msg void OnToolsSetSelectedPath();
  afx_msg void OnToolsHideDesktop();
  afx_msg void OnUpdateToolsHideDesktop(CCmdUI* pCmdUI);
  afx_msg void OnToolsHideMyDocuments();
  afx_msg void OnUpdateToolsHideMyDocuments(CCmdUI* pCmdUI);
  afx_msg void OnToolsHideCurrentUserFolder();
  afx_msg void OnUpdateToolsHideCurrentUserFolder(CCmdUI* pCmdUI);

//Member variables
  CMyTreeFileCtrl m_TreeFile;

  DECLARE_MESSAGE_MAP()
};
